// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef ACTIONBUTTON_HH
#define ACTIONBUTTON_HH

#include <string>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "plf_datatypes.hh"
#include "PinguAction.hh"
#include "GuiObj.hh"
#include "AnimCounter.hh"

// The button class manage a simple button for the button_panel. It
// keeps his position, his surfaces and his font.
class ActionButton : public GuiObj, public GameObj
{
private:
  CL_Font*    font;

  // The basic button surface
  CL_Surface* button;

  // The surface of the action, which is copied onto the button
  // surface. 
  CL_Surface* action;

  // The x and y position of the button
  int x_pos;
  int y_pos;
  string name;

  AnimCounter action_c;
public:  
  ActionButton(int x, int y, string str);

  // Draws the button and increase the animation counter.
  void   draw();
 
  // Not used.
  void   let_move();

  // Returns the name of the action the button represents.
  string get_action_name();

  // Returns true if the button is pressed.
  bool   is_pressed();
};

#endif /* ACTIONBUTTON */

/* EOF */
