// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <cstdio>
#include <iostream>

#include "Hotspot.hh"
#include "globals.hh"
#include "PLF.hh"
#include "PingusResource.hh"

Hotspot::Hotspot(hotspot_data spot)
{
  if (verbose > 2)
    cout << "Creating Hotspot" << endl;

  x_pos = spot.x_pos;
  y_pos = spot.y_pos;
  z_pos = spot.z_pos;

  surface = CL_Res_Surface::load(spot.desc.res_name.c_str(), 
				 *PingusResource::get(spot.desc.filename));
  speed = 10;

  if (speed != -1) {
    count.set_size(surface->get_no_sprs());
    count.set_speed(speed);
  }
}

void 
Hotspot::draw_offset(int x, int y, float s)
{
  assert(surface);
  surface->put_screen((int)((x_pos + x) * s), (int)((y_pos + y) * s),
		      s, s, ++count);
}

/* EOF */
