// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "PinguHolder.hh"

PinguHolder::PinguHolder()
{
  id_count = 0;
  z_pos = 10;
}

void
PinguHolder::push_back(Pingu* pingu)
{
  pingu->set_id(id_count++);
  list<Pingu*>::push_back(pingu);
}

void
PinguHolder::draw_offset(int x_of, int y_of, float s)
{
  //cout << "Drawing pingus" << endl;
  // No optimisation here for s==1.0, because this is done in Pingu
  // itself.
  for(PinguIter pingu = this->begin(); pingu != this->end(); ++pingu) {
    if ((*pingu)->get_status() != dead) {
      (*pingu)->draw_offset(x_of, y_of, s);
    }
  }
}

/* EOF */
