// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "PingusLevelResult.hh"

PingusLevelResult::PingusLevelResult(Result res)
{
  font = CL_Res_Font::load("Fonts/clanfont", *resource());
  background = CL_Res_Surface::load("Textures/stone", *resource());
}

void
PingusLevelResult::draw(void)
{
  return; // Temporary disabled
  char needed[1024];
  char  saved[1024];

  sprintf(needed, "You needed: %-5d", result.get_killed());
  sprintf(saved,  "You saved:  %-5d", result.get_saved());

  background->put_screen(0,0, CL_Display::get_width(), CL_Display::get_height());
  CL_Display::fill_rect(0, 0, CL_Display::get_width(), CL_Display::get_height(), 0.0, 0.0, 0.0, 0.5);

  font->print_left(10,  50, needed);
  font->print_left(10, 100, saved);

  CL_Display::flip_display();

  while(!CL_Mouse::left_pressed()) {
    CL_System::keep_alive();
  }
  while(CL_Mouse::left_pressed()) {
    CL_System::keep_alive();
  }
}

/* EOF */
