// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <iostream>

#include "PingusMenu.hh"

PingusMenu::PingusMenu()
{
  int a = CL_Display::get_width() / 3;

  bg    = CL_Res_Surface::load("Game/logo", *resource());
  start = CL_Res_Surface::load("Buttons/load", *resource());
  load  = CL_Res_Surface::load("Buttons/load", *resource());
  quit  = CL_Res_Surface::load("Buttons/load", *resource());  
  highlight = CL_Res_Surface::load("Hotspots/star", *resource());
 
  start_x = (a / 2) - (start->get_width() / 2);
  start_y = 200;
  
  load_x = (int)((1.5 * a) - (load->get_width() / 2));
  load_y = 275;
  
  quit_x = 2 * a + (a / 2) - (quit->get_width() / 2);
  quit_y = 200;
}

PingusMenu::~PingusMenu()
{
  // Segfault here?!
  /*
  delete start;
  delete load;
  delete quit;
  */
}

void
PingusMenu::draw(void)
{
  bg->put_screen(0, 0);

  start->put_screen(start_x, start_y);
  load->put_screen(load_x, load_y);
  quit->put_screen(quit_x, quit_y);

  switch(current_item) {
  case pmiSTART:
    highlight->put_screen(start_x - 40, start_y - 60); 
    break;
  case pmiLOAD:
    highlight->put_screen(load_x - 40, load_y - 60);
    break;
  case pmiQUIT:
    highlight->put_screen(quit_x - 40, quit_y - 60);
    break;
  default:
    break;
  }

  CL_Display::flip_display();
}

PingusMenu::PingusMenuItem
PingusMenu::select(void)
{
  cout << "PingusMenu::select" << endl;
  PingusMenuItem temp_val = pmiVOID;
  int mouse_x, mouse_y;

  while(CL_Mouse::left_pressed()) 
       CL_System::keep_alive();
       
  while(!CL_Mouse::left_pressed() || current_item == pmiVOID) {
    CL_System::keep_alive();
    mouse_x = CL_Mouse::get_x();
    mouse_y = CL_Mouse::get_y();

    if (temp_val != current_item) {
      temp_val = current_item;
      draw();
    }
    
    if (mouse_x > start_x 
	&& mouse_x < (start_x + start->get_width())
	&& mouse_y > start_y
	&& mouse_y < (start_y + start->get_height())
	) {
      current_item = (PingusMenuItem)pmiSTART;

    } else if (mouse_x > load_x && mouse_x < load_x + load->get_width()
	       && mouse_y > load_y && mouse_y < load_y + load->get_height()) {
      current_item = (PingusMenuItem)pmiLOAD;
    } else if (mouse_x > quit_x && mouse_x < quit_x + quit->get_width()
	       && mouse_y > quit_y && mouse_y < quit_y + quit->get_height()) {
      current_item = (PingusMenuItem)pmiQUIT;
    } else {
      current_item = (PingusMenuItem)pmiVOID;
    }
  }

  while(CL_Mouse::left_pressed()) 
    CL_System::keep_alive();
  
  return current_item;
}

/* EOF */
