// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef RESULT_HH
#define RESULT_HH

#include "LevelInterrupt.hh"

class Result
{
private:
  int  saved;
  int killed;
  int  total;
  int   time;
  int unknown;
  LevelInterrupt n_action;
  int status;
public:
  Result();
  void print();

  int get_total();
  int get_killed();
  int get_saved();
  int get_time();
  LevelInterrupt next_action(void);

  void next_action(LevelInterrupt action);
  int set_total(int);
  int set_killed(int);
  int set_saved(int);
  int set_time(int);
  int set_unknown(int);
};

#endif

/* EOF */
