// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef SERVER_HH
#define SERVER_HH

#include <string>
#include <fstream>
#include "World.hh"
#include "PingusDemo.hh"

class Server
{
protected:
  World* world;
  bool demo_mode;
  string demo_file;
  bool get_next_event;
  PingusDemo demo_out;
  PingusDemo* demo_in;
public:
  Server();
  virtual ~Server();

  World* get_world();
  virtual bool enough_time_passed() = 0;
  virtual void let_move();
  virtual void restart(PLF* level_data, Result& r) {};
  bool is_finished();
  void process_event(string);
  void send_event(string);
  void set_demo(string);
  void set_record_file(string);
  virtual void toggle_fast_forward(void) = 0;
  virtual void toggle_pause(void) = 0;
};

#endif

/* EOF */
