// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef BOMBER_HH
#define BOMBER_HH

#include "../PinguAction.hh"

PinguAction* make_Bomber();

class Bomber : public PinguAction
{
private:
  bool particle_thrown;
  static CL_Surface* static_surface;
  CL_Surface* bomber_radius;
public:
  Bomber();

  void  init(void);
  string name() { return "Bomber"; };
  PinguEnvironment get_environment() { return (PinguEnvironment)(land | sky); };
  void  let_move();
  bool  can_reset() { return false; };
  int   activation_time() { return 50; };
  PinguAction* create(void);
};

#endif

/* EOF */
