// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef BRIDGER_HH
#define BRIDGER_HH

#include "../PinguAction.hh"

PinguAction* make_Bridger();

class Bridger : public PinguAction
{
private:
  CL_Surface* brick;
  int bricks;
  int step;
public:
  Bridger();

  PinguAction* create(void);
  PinguEnvironment get_environment() { return (PinguEnvironment)land; };

  void   init(void);
  string name() { return "Bridger"; };
  void   let_move();
};

#endif

/* EOF */
